#!/usr/bin/perl -w
#!/usr/local/bin/perl -w
#!/bin/perl -w

## Author: Jeong-Hyeon Choi
## Date: 2008

## Description

## Usage:
## CHECK usage with option  -h

## $Id: perl_template,v 1.2 2007-09-21 22:51:23 jeochoi Exp $


use Getopt::Long qw(:config no_ignore_case);
use File::Basename;

my ($helpFlag, $inFile, $featureFile, $sqlFile, $outFile, $verbose, $quiet, $strand, $all, $allow);

GetOptions(
	"h|?|help"		=> \$helpFlag,	
	"input=s"		=> \$inFile,		## input file
	"feature=s"		=> \$featureFile,		## input file
	"output=s"		=> \$outFile,		## output file
	"verbose+"		=> \$verbose,		## verbose output
	"quiet"			=> \$quiet,
	"strand!"		=> \$strand,
	"all!"			=> \$all,
	"allow=i"		=> \$allow,
	"sql=s"			=> \$sqlFile,
) || die "\n";

checkOptions();

$ENV{PATH} .= ':' . dirname($0);

my ($iref, $iid, $istart, $iend, $idir, $ies, $iee, $ics, $ice) = $sqlFile ?
	split(/\s+/, `goldenpath_sql.pl -a chrom -a name -a txStart -a txEnd -a strand -a exonStarts -a exonEnds -a cdsStart -a cdsEnd $sqlFile`) :
	(3, 2, 5, 6, 4, 10, 11, 7, 8);

my $cmd = $all ? 'addNeighbors.pl' : $strand ? 'addNearestStrandedNeighbor.pl': 'addNearestNeighbor.pl';
$cmd .= " -u -n RefGene -ref $iref -id $iid -start $istart -end $iend -dir $idir -es $ies -ee $iee -cs $ics -ce $ice";
$cmd .= " -allow $allow" if $allow;
$cmd .= " -i $inFile" if $inFile;
$cmd .= " -f $featureFile" if $featureFile;
$cmd .= " -o $outFile" if $outFile;
$cmd .= " -verbose" if $verbose;

#print STDERR "$cmd\n";
!system($cmd) || die "Error in $cmd\n";

#-------------------------------------------------------------------------------

sub openInput
{
	my ($fileName) = @_;

	return *STDIN unless defined $fileName;

	my ($fd);
	open($fd, $fileName =~ /.gz$/ ? "zcat $fileName |" : $fileName) || die("Open error: $fileName");
	return $fd;
}

sub openOutput
{
	my ($fileName) = @_;

	return *STDOUT unless defined $fileName;

	my ($fd);
	open($fd, $fileName =~ /.gz$/ ? "| zcat -c > $fileName" : ">$fileName") || die("Open error: $fileName");
	return $fd;
}

sub checkOptions
{
	$inFile  = shift(@ARGV) if !defined $inFile  && @ARGV > 0;
	$outFile = shift(@ARGV) if !defined $outFile && @ARGV > 0;
	die "The output file name is the same as the input file name\n" if defined $inFile && defined $outFile && $inFile eq $outFile;

	if ($helpFlag || (!$inFile && !$featureFile))
	{
		die("Arguments: -f goldenpath_knownGene [[-i] in_file] [[-o] out_file] [-v] [-q]\n"
		  . "\t\n"
		  );
	}
}
