#!/usr/bin/perl -w
#!/usr/local/bin/perl -w
#!/bin/perl -w

## Author: Jeong-Hyeon Choi
## Date: 2008

## Description

## Usage:
## CHECK usage with option  -h

## $Id: perl_template,v 1.2 2007-09-21 22:51:23 jeochoi Exp $


use Getopt::Long qw(:config no_ignore_case);
use File::Basename;

my ($helpFlag, $inFile, $featureFile, $sqlFile, $outFile, $verbose, $quiet);

GetOptions(
	"h|?|help"		=> \$helpFlag,	
	"input=s"		=> \$inFile,		## input file
	"feature=s"		=> \$featureFile,		## input file
	"output=s"		=> \$outFile,		## output file
	"verbose+"		=> \$verbose,		## verbose output
	"quiet"			=> \$quiet,
	"sql=s"			=> \$sqlFile,
) || die "\n";

checkOptions();

$ENV{PATH} .= ':' . dirname($0);

my ($iref, $iid, $istart, $iend, $dir) = $sqlFile ?
	split(/\s+/, `goldenpath_sql.pl -a genoName -a repClass -a genoStart -a genoEnd -a strand $sqlFile`) :
	(6, 12, 7, 8, 10);

my $cmd = 'addNearestNeighbor.pl -nou -n Rmsk -ref 6 -id 12 -start 7 -end 8 -dir 10';
$cmd .= " -i $inFile" if $inFile;
$cmd .= " -f $featureFile" if $featureFile;
$cmd .= " -o $outFile" if $outFile;

#print STDERR "$cmd\n";
!system($cmd) || die "Error in $cmd\n";

#-------------------------------------------------------------------------------

sub openInput
{
	my ($fileName) = @_;

	return *STDIN unless defined $fileName;

	my ($fd);
	open($fd, $fileName =~ /.gz$/ ? "zcat $fileName |" : $fileName) || die("Open error: $fileName");
	return $fd;
}

sub openOutput
{
	my ($fileName) = @_;

	return *STDOUT unless defined $fileName;

	my ($fd);
	open($fd, $fileName =~ /.gz$/ ? "| zcat -c > $fileName" : ">$fileName") || die("Open error: $fileName");
	return $fd;
}

sub checkOptions
{
	$inFile  = shift(@ARGV) if !defined $inFile  && @ARGV > 0;
	$outFile = shift(@ARGV) if !defined $outFile && @ARGV > 0;
	die "The output file name is the same as the input file name\n" if defined $inFile && defined $outFile && $inFile eq $outFile;

	if ($helpFlag || (!$inFile && !$featureFile))
	{
		die("Arguments: -f goldenpath_rmsk [[-i] in_file] [[-o] out_file] [-v] [-q]\n"
		  . "\t\n"
		  );
	}
}
